package com.szpg.task;

import com.szpg.db.dao.impl.PgAcuRdcmdDaoImpl;
import com.szpg.db.data.PgAcuRdcmd;
import com.szpg.plc.message.AppCommand;
import com.szpg.plc.message.command.read.ReadFjStatCommand;
import com.szpg.plc.protocol.DTProtocolInterface;
import com.szpg.plc.protocol.ProtocolFactory;
import com.szpg.plc.server.ACUClient;
import com.szpg.plc.server.ACUClientUtil;
import com.szpg.plc.util.ByteUtil;

public class ReadFjStatTask implements Runnable {

	private ACUClient client;
	private AppCommand appCommand;

	public ReadFjStatTask(ACUClient client, AppCommand command) {
		this.client = client;
		this.appCommand = command;
	}

	@Override
	public void run() {
		DTProtocolInterface finspi = ProtocolFactory.getDefaultDTProtocol();
		byte[] content = finspi.messageToBytes(appCommand);
		
		// 发送读取风机运行状态内存命令
		ACUClientUtil.getInstance().sendACUCommand(client, content);
		
		ReadFjStatCommand fjStatCmd = (ReadFjStatCommand) appCommand;

		// 发送完成之后将命令保存在数据库中
		PgAcuRdcmd cmd = new PgAcuRdcmd();
		cmd.setCmd_type(fjStatCmd.getCommandType());
		cmd.setDest(fjStatCmd.getDestinationId());
		cmd.setMem_area_cd(ByteUtil.binToHexString(new byte[] { fjStatCmd.getMemoryArea() }));
		cmd.setStart_mem_word(fjStatCmd.getStartAddress().substring(0, 4));
		cmd.setStart_mem_bit(fjStatCmd.getStartAddress().substring(4));
		cmd.setCount_word(fjStatCmd.getCountWord());
		cmd.setCount_bit(fjStatCmd.getCountBit());
		cmd.setCount_sensor(fjStatCmd.getCountSensor());
		
		new PgAcuRdcmdDaoImpl().addCmdRecord(cmd);
	}

}
